#!/bin/bash
# This script will install PSU12-Sritrang on your existing ubuntu server
# update by pom 10-may-2016 
# update by wiboon 18-may-2016
# update by wiboon 20-Jun-2016
# update by wiboon 14-Mar-2018

if ! [ "${HOME}" = "/root" ]; then
  echo 'Please run command "sudo su -" for set HOME to /root'
  exit 
fi

#--Check user confirmation before installation--
while true; do
    echo "This script will install PSU12-Sritrang on your existing ubuntu server (14.04.x or higher)"
    read -p "Confirm to start installation? (y/n)" yn
    case $yn in
        [Yy]* ) CONFIRM_INSTALL="yes"; break;;
        [Nn]* ) CONFIRM_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${CONFIRM_INSTALL}" = "no" ]; then
  exit 
fi

#--Setting some variables
start1=$(date)
DIR1=${PWD}

#--Update ubuntu packages--
apt-get update && apt-get -y dist-upgrade
apt-get -y autoremove

#--Install new packages--
#
#utitlity packages
apt-get -y install curl dialog expect whois nbtscan netmask nmap imagemagick unzip wakeonlan lynx w3m

#cloning packages
apt-get -y install udpcast
apt-get -y install partclone

#pxeboot via tftpd
apt-get -y install tftpd-hpa tftp

#apache web server
apt-get -y install apache2 apache2-doc libapache2-mod-perl2

#splash images
apt-get -y install grub2-splashimages

#php
codename=$(lsb_release -c | awk '{print $2}')
if [ "${codename}" = "xenial" ]; then
  apt-get -y install php7.0
  apt-get -y install libapache2-mod-php7.0
else
  if [ "${codename}" = "trusty" ]; then
    apt-get -y install php5
    apt-get -y install libapache2-mod-php5
  else
    apt-get -y install php
    apt-get -y install libapache2-mod-php
  fi
fi

#vsftpd
apt-get -y install vsftpd

#nfs
apt-get -y install portmap nfs-kernel-server

#POP3 mail
apt-get -y install dovecot-common dovecot-pop3d

#host firewall
apt-get -y install shorewall
cp /usr/share/doc/shorewall/examples/one-interface/zones /etc/shorewall
cp /usr/share/doc/shorewall/examples/one-interface/interfaces /etc/shorewall
cp /usr/share/doc/shorewall/examples/one-interface/policy /etc/shorewall
cp /usr/share/doc/shorewall/examples/one-interface/rules /etc/shorewall

#dhcp server
apt-get -y install isc-dhcp-server

#utility report dhcp IP leases
wget -P /tmp http://ftp.psu.ac.th/pub/omar/reportdhcp.pl-2.1.tar.gz
tar -zxvf /tmp/reportdhcp.pl-2.1.tar.gz -C /usr/lib/cgi-bin
# config file for reportdhcp
cp ${DIR1}/reportdhcp.pl  /usr/lib/cgi-bin
chmod +x /usr/lib/cgi-bin/reportdhcp.pl

#get mac-ip from local network
#mkdir -p /var/www/log
#mkdir -p ${HOME}/mac-ip
#wget -P ${HOME}/mac-ip http://ftp.psu.ac.th/pub/psu-12/dists-12/home/mama/mac-ip/get-localnet.sh
#wget -P ${HOME}/mac-ip http://ftp.psu.ac.th/pub/psu-12/dists-12/home/mama/mac-ip/myhour.sh
#wget -P /etc/cron.d http://ftp.psu.ac.th/pub/psu-12/dists-12/etc/cron.d/myhour

#Install MRTG using PSU Installer psu-mrtg
wget http://ftp.psu.ac.th/pub/psu-mrtg/psu-mrtg.tgz -N -P /tmp 
tar -zxpvf /tmp/psu-mrtg.tgz -C /tmp 
cd /tmp/psu-mrtg
sh install-psu-mrtg.sh 

#Install FreeRADIUS using PSU Installer psu-radius
wget http://ftp.psu.ac.th/pub/psu-radius/psu-radius.tgz -N -P /tmp 
tar -zxpvf /tmp/psu-radius.tgz -C /tmp 
cd /tmp/psu-radius 
sh install-psu-radius.sh 

#Install Windows user login log using PSU Installer psu-ticker
wget http://ftp.psu.ac.th/pub/psu-ticker/psu-ticker.tgz -N -P /tmp 
tar -zxpvf /tmp/psu-ticker.tgz -C /tmp 
cd /tmp/psu-ticker 
sh install-psu-ticker.sh 

#--Configuration Section--
#
#config apache2 
file1000=/etc/apache2/sites-available/000-default.conf
cp $file1000 $file1000.$(date +%F-%H%M%S)
sed -i '/DocumentRoot/ c DocumentRoot /var/www' $file1000
cp /etc/apache2/conf-available/serve-cgi-bin.conf /etc/apache2/conf-available/serve-cgi-bin.conf.$(date +%F-%H%M%S)
cp ${DIR1}/serve-cgi-bin.conf      /etc/apache2/conf-available
echo "Servername localhost"    >>  /etc/apache2/apache2.conf
echo "AddDefaultCharset UTF-8" >>  /etc/apache2/conf-available/charset.conf
a2enmod cgi

#download PSU12-Sritrang all scripts from ftp server to a local temporary directory
DIR2=${DIR1}/scripts
wget -r -N -l1 -nd -A* ftp.psu.ac.th/pub/psu12-sritrang/download/scripts -P ${DIR2}
rm ${DIR2}/index.htm*
rm ${DIR2}/*.gif

#config tftp directories
mkdir -p /var/lib/tftpboot/sysresccd
mkdir -p /var/lib/tftpboot/linuxmint
mkdir -p /var/lib/tftpboot/psulib
mkdir -p /var/lib/tftpboot/custom
mkdir -p /var/lib/tftpboot/boot
mkdir -p /var/lib/tftpboot/pxelinux.cfg

#config sysresccd Live CD
VERSION2=5.1.2
wget http://ftp.psu.ac.th/pub/sysresccd/systemrescuecd-x86-${VERSION2}.iso -P /tmp
mkdir /tmp/sysresccd
mount -o loop /tmp/systemrescuecd-x86-${VERSION2}.iso /tmp/sysresccd
cp -v /tmp/sysresccd/isolinux/pxelinux.0 /var/lib/tftpboot/
cp -v /tmp/sysresccd/sysrcd* /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/altker32 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/altker64 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/initram.igz /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/chain.c32 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/menu.c32 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/memdisk /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/rescue32 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/isolinux/vesamenu.c32 /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/bootdisk/freedos.img /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/bootdisk/hdt.img /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/bootdisk/mhdd.img /var/lib/tftpboot/sysresccd/
cp -v /tmp/sysresccd/bootdisk/memtestp /var/lib/tftpboot/sysresccd/
umount /tmp/sysresccd 

#config sysresccd for PXE boot autorun
mkdir -p /var/www/sysresccd
ln -svf /var/lib/tftpboot/sysresccd/sysrcd.* /var/www/sysresccd/
cp ${DIR2}/autorun*               /var/www/sysresccd/

#config PXE boot menu zone1
cp ${DIR1}/picture/penguinpom.jpg  /var/lib/tftpboot/sysresccd/psu-12.jpg
cp ${DIR1}/default   /var/lib/tftpboot/pxelinux.cfg/
wget -r -N -l1 -nd -A.mnu ftp.psu.ac.th/pub/psu12-sritrang/download/scripts/zone1 -P /var/lib/tftpboot/zone1

#config /root files (HOME is /root after command "sudo su -")
LISTSHELL="install-grub2.sh makezone.sh backup-server.sh change-mtu.sh"
for H in ${LISTSHELL}
do
	cp ${DIR2}/${H} ${HOME}
done
cp -r ${DIR1}/backuppxezone        ${HOME}
cp -r ${DIR2}/startroot.sh         ${HOME}
cp -r ${DIR1}/.bash_login_root     ${HOME}/.bash_login 
cp -r ${DIR2}                      ${HOME}	
cp ${DIR2}/easy-config.sh          ${HOME}
ln -s ${HOME}/scripts/mainmenu.sh  ${HOME}/mainmenu.sh

#config user papa, prnews and sendfile
#
useradd -m -s /bin/bash papa
echo
echo "Added user name papa"
while true; do
echo "Please input password for user name papa (example: papa123)"
passwd papa
if [ $? -eq 0 ]; then
  echo password OK
  exit
fi
done
#
useradd -m -s /bin/bash prnews
echo
echo "Added user name prnews"
while true; do
echo "Please input password for user name prnews (example: 123456)"
passwd prnews
if [ $? -eq 0 ]; then
  echo password OK
  exit
fi
done
#
useradd -m -s /bin/bash sendfile
echo
echo "Added user name sendfile"
while true; do
echo "Please input password for user name sendfile (example: 123456)"
passwd sendfile
if [ $? -eq 0 ]; then
  echo password OK
  exit
fi
done
#

#config /home/papa
wget -r -N -l1 -nd -A* ftp.psu.ac.th/pub/psu12-sritrang/download/scripts/papa -P /home/papa
rm /home/papa/index.htm*
rm /home/papa/*.gif
rm /home/papa/papa
mkdir -p /home/papa/swap-area 
echo "bash mystart.sh" >  /home/papa/.bash_login
echo "logout"          >> /home/papa/.bash_login

#config cloning directories
mkdir -p /var/www/cloning
mkdir -p /var/www/cloning/zone1

#config cloning scripts
cp ${DIR2}/welcome.sh             /var/www/cloning
cp ${DIR2}/backup.sh              /var/www/cloning
cp ${DIR2}/menubackuprestore.sh   /var/www/cloning

#config directories permission for user papa
chown -Rv papa:papa			 /home/papa
chown -Rv papa:papa			 /var/lib/tftpboot/*
chown -Rv papa:papa			 /var/www/cloning
chown -Rv papa:papa			 /var/www/sysresccd

#config /home/prnews and image while PC booting
cp ${DIR1}/picture/viewpsu12.jpg  /
cp ${DIR1}/picture/*              /home/prnews
chown -Rv prnews  	            /home/prnews 

#config web server home page and put some files in directory /var/www
cp ${DIR1}/index.php.var      	 /var/www/index.php
cp -r ${DIR1}/reportdhcp      	 /var/www
cp -r ${DIR1}/mrtg/index.php  	 /var/www/mrtg
ln -s /etc/dhcp/dhcpd.conf    	 /var/www/dhcpd.txt
ln -s /home/prnews    	      /var/www/
cp -r ${DIR1}/test               /var/www 

#config freeradius file for editsharedsecret.sh
cp -p /etc/freeradius/clients.conf    /etc/freeradius/clients.conf.master

#config ubuntu source list for changesourceslist.sh
cp -p /etc/apt/sources.list           /etc/apt/sources.list.th.archive.ubuntu.com

#config system configuration files
#
#backup existing file then copy our custom file
LIST="/etc/profile /etc/ssh/sshd_config /etc/default/nfs-kernel-server /etc/default/nfs-common /etc/exports /etc/dovecot/dovecot.conf /etc/default/isc-dhcp-server /etc/vsftpd.conf /etc/network/interfaces"
for I in $LIST
do
	cp ${I} ${I}.org
	cp ${DIR1}/$(basename "${I}") ${I}
done

#config custom network configuration
cp ${DIR1}/interface*                 /etc/network
cp ${DIR1}/dhcp*                      /etc/dhcp
sed -i '/start on runlevel/ s/^/#/g'  /etc/init/isc-dhcp-server.conf

#config boot grub
cp /etc/default/grub  /etc/default/grub.org
cp ${DIR1}/grub       /etc/default
update-grub

#--End of installation--

echo "-------------------------------------------------"
echo "Start time: " $start1
echo "Finished time: " $(date)
echo "-------------------------------------------------"
echo "Install PSU12-Sritrang completed. Thank you. "
echo "-------------------------------------------------"

#--Copy startup script for priviledge user account--
cd ${DIR1}
user99=$(grep "1000:.*/home" /etc/passwd | cut -d: -f1)
sudo cp ${DIR2}/startmama.sh   /home/${user99}
cp  ${DIR1}/.bash_login_mama   /home/${user99}/.bash_login
chown ${user99}:${user99}      /home/${user99}/.bash_login
bash ${DIR2}/countdown2.sh
#End.

